﻿// -*- C++ -*-
/*!
 * @file  RockPaperScissorsFilter.cpp
 * @brief RockPaperScissorsFilter
 * @date $Date$
 *
 * $Id$
 */

#include "RockPaperScissorsFilter.h"

// Module specification
// <rtc-template block="module_spec">
static const char* rockpaperscissorsfilter_spec[] =
  {
    "implementation_id", "RockPaperScissorsFilter",
    "type_name",         "RockPaperScissorsFilter",
    "description",       "RockPaperScissorsFilter",
    "version",           "1.0.0",
    "vendor",            "AG",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };

  int num;
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
RockPaperScissorsFilter::RockPaperScissorsFilter(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_RPSdataIn("RPSdata", m_RPSdata),
    m_FilterdataOut("Filterdata", m_Filterdata)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
RockPaperScissorsFilter::~RockPaperScissorsFilter()
{
}



RTC::ReturnCode_t RockPaperScissorsFilter::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("RPSdata", m_RPSdataIn);
  
  // Set OutPort buffer
  addOutPort("Filterdata", m_FilterdataOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t RockPaperScissorsFilter::onActivated(RTC::UniqueId ec_id)
{
	num = 0;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RockPaperScissorsFilter::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RockPaperScissorsFilter::onExecute(RTC::UniqueId ec_id)
{
		if (m_RPSdataIn.isNew())
		{
			m_RPSdataIn.read();
			std::cout << "Received: " << m_RPSdata.data << std::endl;

			if (!strcmp(m_RPSdata.data, "Rock"))
			{
				num = 1;
			}
			else if (!strcmp(m_RPSdata.data, "Paper"))
			{
				num = 2;
			}
			else if (!strcmp(m_RPSdata.data, "Scissors"))
			{
				num = 3;
			}
			else;
		}
		else;

		m_Filterdata.data = num;
		std::cout << "Send: " << m_Filterdata.data << std::endl;
		m_FilterdataOut.write();

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RockPaperScissorsFilter::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void RockPaperScissorsFilterInit(RTC::Manager* manager)
  {
    coil::Properties profile(rockpaperscissorsfilter_spec);
    manager->registerFactory(profile,
                             RTC::Create<RockPaperScissorsFilter>,
                             RTC::Delete<RockPaperScissorsFilter>);
  }
  
};


